summaryrefslogtreecommitdiff
path: root/tests/chroot
diff options
context:
space:
mode:
authorGiuseppe Scrivano <gscrivano@gnu.org>2009-05-01 23:50:11 +0200
committerJim Meyering <meyering@redhat.com>2009-05-26 15:10:22 +0200
commitc45c51fe97193898f3909dcf5e4c0e117ab239a2 (patch)
tree9a146adbde39cce97dbd4e1ee5aa3eb296fe02a6 /tests/chroot
parent39285f6008a26ff1d5facbffcbf12f57d60564d1 (diff)
downloadcoreutils-c45c51fe97193898f3909dcf5e4c0e117ab239a2.tar.xz
chroot: accept new options --userspec=U:G and --groups=G1,G2,G3
* NEWS: Note chroot's new options. * doc/coreutils.texi: Document them. * src/chroot.c (main): Add support for --userspec and --groups. * tests/Makefile.am (root-tests): Add chroot/credentials. * tests/chroot/credentials: New file. * tests/test-lib.sh: Define NON_ROOT_GROUP to a default value.
Diffstat (limited to 'tests/chroot')
-rwxr-xr-xtests/chroot/credentials43
1 files changed, 43 insertions, 0 deletions
diff --git a/tests/chroot/credentials b/tests/chroot/credentials
new file mode 100755
index 000000000..23d66bd62
--- /dev/null
+++ b/tests/chroot/credentials
@@ -0,0 +1,43 @@
+#!/bin/sh
+# Verify that the credentials are changed correctly.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+
+if test "$VERBOSE" = yes; then
+ set -x
+ chroot --version
+fi
+
+. $srcdir/test-lib.sh
+
+require_root_
+
+fail=0
+
+# Verify that root credentials are kept.
+test $(chroot / whoami) = root || fail=1
+test "$(groups)" = "$(chroot / groups)" || fail=1
+
+# Verify that credentials are changed correctly.
+test "$(chroot --userspec=$NON_ROOT_USERNAME:$NON_ROOT_GROUP / whoami)" != root \
+ || fail=1
+
+# Verify that there are no additional groups.
+test "$(chroot --userspec=$NON_ROOT_USERNAME:$NON_ROOT_GROUP --groups= / id -nG)"\
+ = $NON_ROOT_GROUP || fail=1
+
+Exit $fail